"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var web_storage_1 = require("./web-storage");
var storageContainer = {};
function getStorage(type) {
    if (!storageContainer[type]) {
        storageContainer[type] = new web_storage_1.WebStorage(type);
    }
    return storageContainer[type];
}
function webStorageDecorator(type, key) {
    return function (target, propertyName) {
        var storingKey = key || propertyName;
        var webStorage = getStorage(type);
        Object.defineProperty(target, propertyName, {
            get: function () {
                return webStorage.get(storingKey);
            },
            set: function (value) {
                webStorage.set(storingKey, value);
            },
        });
    };
}
function SessionStorage(key) {
    return webStorageDecorator('sessionStorage', key);
}
exports.SessionStorage = SessionStorage;
function LocalStorage(key) {
    return webStorageDecorator('localStorage', key);
}
exports.LocalStorage = LocalStorage;
//# sourceMappingURL=decorators.js.map