/**
 * A dummy storage that is used to store data in memory if local/session storage is not supported to
 * avoid errors. The data stored in InMemoryStorage gets cleared when the page is closed or reloaded.
 * */
export declare class InMemoryStorage implements Storage {
    private _length;
    private buffer;
    readonly length: number;
    clear(): void;
    getItem(key: string): string | any;
    key(index: number): string | any;
    removeItem(key: string): void;
    setItem(key: string, data: string): void;
    [key: string]: any;
    [index: number]: string;
}
