"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var rxjs_1 = require("rxjs");
var web_storage_1 = require("./web-storage");
var WebStorageController = /** @class */ (function (_super) {
    __extends(WebStorageController, _super);
    function WebStorageController() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._actions = new rxjs_1.Subject();
        _this._errors = new rxjs_1.Subject();
        return _this;
    }
    Object.defineProperty(WebStorageController.prototype, "actions", {
        get: function () {
            return this._actions.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WebStorageController.prototype, "errors", {
        get: function () {
            return this._errors.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    WebStorageController.prototype.get = function (key) {
        try {
            return _super.prototype.get.call(this, key);
        }
        catch (e) {
            this._errors.next(e);
            return null;
        }
    };
    WebStorageController.prototype.set = function (key, value) {
        try {
            var success = _super.prototype.set.call(this, key, value);
            if (success) {
                this._notify('set', key, value);
            }
        }
        catch (e) {
            this._errors.next(e);
            return false;
        }
        return true;
    };
    WebStorageController.prototype.remove = function (key) {
        try {
            var success = _super.prototype.remove.call(this, key);
            if (success) {
                this._notify('remove', key);
            }
        }
        catch (e) {
            this._errors.next(e);
            return false;
        }
        return true;
    };
    WebStorageController.prototype.clear = function () {
        try {
            _super.prototype.clear.call(this);
        }
        catch (e) {
            this._errors.next(e);
        }
    };
    WebStorageController.prototype._notify = function (action, key, value) {
        this._actions.next({
            type: this._storageType,
            action: action,
            key: key,
            value: value,
        });
    };
    return WebStorageController;
}(web_storage_1.WebStorage));
exports.WebStorageController = WebStorageController;
//# sourceMappingURL=web-storage.controller.js.map